/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.minimips.op.mtc0;
import ru.ispras.microtesk.model.minimips.mode.REG;
import ru.ispras.microtesk.model.minimips.mode.RCOP0;

/**
 * The {@code DecoderMtc0} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMtc0 extends DecoderItem {
  private static DecoderMtc0 instance = null;

  public static DecoderMtc0 get() {
    if (null == instance) {
      instance = new DecoderMtc0();
    }
    return instance;
  }

  private DecoderMtc0() {
    super(
        32,
        true,
        "01000000100000000000000000000000",
        "11111111111000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    REG rt = null;
    RCOP0 cs = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000000100", 2, 11))) {
      return null;
    }
    rt = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == rt) {
      return null;
    }
    cs = (RCOP0) readNextPrimitive(image, DecoderRCOP0.get());
    if (null == cs) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00000000000", 2, 11))) {
      return null;
    }

    return newResult(new mtc0(rt, cs));
  }
}
