/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.decoder;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.vliw.op.MTF;
import ru.ispras.microtesk.model.vliw.mode.R;
import ru.ispras.microtesk.model.vliw.mode.F;

/**
 * The {@code DecoderMTF} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMTF extends DecoderItem {
  private static DecoderMTF instance = null;

  public static DecoderMTF get() {
    if (null == instance) {
      instance = new DecoderMTF();
    }
    return instance;
  }

  private DecoderMTF() {
    super(
        32,
        true,
        "01000100100000000000000000000000",
        "11111111111000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rt = null;
    F fs = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000100100", 2, 11))) {
      return null;
    }
    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }
    fs = (F) readNextPrimitive(image, DecoderF.get());
    if (null == fs) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00000000000", 2, 11))) {
      return null;
    }

    return newResult(new MTF(rt, fs));
  }
}
