/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.x86.op.ADC_R16R16;
import ru.ispras.microtesk.model.x86.mode.GPR16;

/**
 * The {@code DecoderADC_R16R16} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderADC_R16R16 extends DecoderItem {
  private static DecoderADC_R16R16 instance = null;

  public static DecoderADC_R16R16 get() {
    if (null == instance) {
      instance = new DecoderADC_R16R16();
    }
    return instance;
  }

  private DecoderADC_R16R16() {
    super(
        16,
        true,
        "0001001111000000",
        "1111111111000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    GPR16 op1 = null;
    GPR16 op2 = null;

    if (!matchNextOpc(image, BitVector.valueOf("0001001111", 2, 10))) {
      return null;
    }
    op1 = (GPR16) readNextPrimitive(image, DecoderGPR16.get());
    if (null == op1) {
      return null;
    }
    op2 = (GPR16) readNextPrimitive(image, DecoderGPR16.get());
    if (null == op2) {
      return null;
    }

    return newResult(new ADC_R16R16(op1, op2));
  }
}
