/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.x86.op.PUSH_R16;
import ru.ispras.microtesk.model.x86.mode.GPR16;

/**
 * The {@code DecoderPUSH_R16} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderPUSH_R16 extends DecoderItem {
  private static DecoderPUSH_R16 instance = null;

  public static DecoderPUSH_R16 get() {
    if (null == instance) {
      instance = new DecoderPUSH_R16();
    }
    return instance;
  }

  private DecoderPUSH_R16() {
    super(
        7,
        true,
        "1010000",
        "1111000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    GPR16 src = null;

    if (!matchNextOpc(image, BitVector.valueOf("1010", 2, 4))) {
      return null;
    }
    src = (GPR16) readNextPrimitive(image, DecoderGPR16.get());
    if (null == src) {
      return null;
    }

    return newResult(new PUSH_R16(src));
  }
}
