/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.x86.op.XOR_R16M16;
import ru.ispras.microtesk.model.x86.mode.RSEG16;
import ru.ispras.microtesk.model.x86.mode.GPR16;
import ru.ispras.microtesk.model.api.IsaPrimitive;

/**
 * The {@code DecoderXOR_R16M16} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderXOR_R16M16 extends DecoderItem {
  private static DecoderXOR_R16M16 instance = null;

  public static DecoderXOR_R16M16 get() {
    if (null == instance) {
      instance = new DecoderXOR_R16M16();
    }
    return instance;
  }

  private DecoderXOR_R16M16() {
    super(
        41,
        false,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    RSEG16 seg_ovrd = null;
    GPR16 op1 = null;
    IsaPrimitive op2 = null;

    if (!matchNextOpc(image, BitVector.valueOf("001", 2, 3))) {
      return null;
    }
    seg_ovrd = (RSEG16) readNextPrimitive(image, DecoderRSEG16.get());
    if (null == seg_ovrd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("11000110011", 2, 11))) {
      return null;
    }
    op1 = (GPR16) readNextPrimitive(image, DecoderGPR16.get());
    if (null == op1) {
      return null;
    }
    op2 = (IsaPrimitive) readNextPrimitive(image, DecoderMOFFS.get());
    if (null == op2) {
      return null;
    }

    return newResult(new XOR_R16M16(seg_ovrd, op1, op2));
  }
}
